﻿from tkinter import *
import time
#■繰返し回数（点の数に一致:多くすると精細な図形になるが遅くなる）
MAX=2500
#■表示用計算
def Map(mu, a, b):
    X=0.1
    XX=X*X
    Y=0.0
    mm2=2*(1.0-mu)
    G = mu * X + mm2 * XX / (1.0 + XX)
    for i in range(MAX):
        XP = int(500.0 - X * 10)
        YP = int(200.0 - Y * 10)
        canvas.coords(FID[i],XP,YP,XP,YP) #表示
        XN = X
        X = Y + a * (1.0 - b * Y * Y) * Y + G
        XX=X*X
        G = mu * X + mm2 * XX / (1.0 + XX)
        Y = -XN + G
    tk.update()
#■待ち処理等
def wait():
    tk.update_idletasks()
    time.sleep(0.0001)
def strdt(mu):
    return "μ = {:+f}".format(float(mu))
#■メイン処理
#キャンバスの定義
tk=Tk()
tk.title("Gumowski-Mira Map")
canvas=Canvas(tk, width=1000,height=400)
canvas.pack()
#表示用の点の準備
FID=[0 for j in range(MAX)]
for j in range(MAX):
    FID[j]=canvas.create_rectangle(0,0,0,0,fill="#007700", outline='')
#アニメーション
mu=-1
a=0.08
b=0.05
dm=0.001
strID=canvas.create_text(100,10,text=strdt(mu), font=('ＭＳ ゴシック',10))
while True:
    mu+=dm
    if mu>1.0:
        mu=-1.0
    canvas.itemconfig(strID,text=strdt(mu))
    Map(mu,a,b)
    wait()
        




    
